from pytest_common import pytest, run


@pytest.mark.parametrize(
    "rects, field",
    [
        ([
             (1, 2, 10, 10, "*"),
             (-2, -1, 10, 10, "#"),
             (3, 4, -10, 10, "@"),
             (5, 6, 10, -10, "%"),
         ],
         [
             "............%%%%%%%%%%",
             "............%%%%%%%%%%",
             "............%%%%%%%%%%",
             ".....#######%%%%%%%%%%",
             ".....#######%%%%%%%%%%",
             ".....#######%%%%%%%%%%",
             ".....#######%%%%%%%%%%",
             ".....#######%%%%%%%%%%",
             "@@@@@@@@@@##%%%%%%%%%%",
             "@@@@@@@@@@##%%%%%%%%%%",
             "@@@@@@@@@@#####***....",
             "@@@@@@@@@@#####***....",
             "@@@@@@@@@@#####***....",
             "@@@@@@@@@@********....",
             "@@@@@@@@@@********....",
             "@@@@@@@@@@********....",
             "@@@@@@@@@@............",
             "@@@@@@@@@@............",
         ]),
        ([
             (0, 0, 4, 4, "#"),
             (5, 5, 0, 0, "@"),
             (-3, -2, 0, 100, "^"),
             (12, 23, 100, 0, "&"),
         ],
         [
             "####",
             "####",
             "####",
             "####",
         ]),
        ([
             (1, 2, 10, 10, "*"),
             (-2, -1, 10, 10, "#"),
             (3, 4, -10, 10, "@"),
             (5, 6, 10, -10, "%"),
             (-8, -8, 30, 30, "X"),
         ],
         ["X" * 30] * 30),
        ([
             (5, 7, 1, 100, '#'),
             (5, 40, 1, 30, '*'),
             (-3, -4, 60, 1, '1'),
             (5, 8, 1, 44, '2'),
         ],
         [
             '1' * 60,
             *['.' * 60] * 10,
             '.' * 8 + '#' + '.' * 51,
             *['.' * 8 + '2' + '.' * 51] * 44,
             *['.' * 8 + '*' + '.' * 51] * 18,
             *['.' * 8 + '#' + '.' * 51] * 37,
         ]),
    ]
)
def test_trimimage(rects, field):
    result = run(
        __file__, 'solution.py',
        input='\n'.join(' '.join(str(n) for n in rect) for rect in rects) +
              '\n0 0 0 0 0'
    )
    assert result.returncode == 0, result.stderr
    assert result.stdout.strip() == '\n'.join(field), result.stdout
